
#!/usr/bin/env python3
import random
import string
import sys
import math
import numpy as np
import timeit
import matplotlib.pyplot as plt

def max_element(array):
    """In this function, we will find the maximum element in an array.
    Use the divide and conquer approach to solve the problem.

    Try to benchmark the performance of this function with the "max" function in python and "naive" approach.

    Input: array - a list of integers
    Output: the maximum element in the array
    """
    pass

def coin_change(coins, amount):
    """In this function, we will find the minimum number of coins required to make up the given amount.

    Use the recursive approach to solve the problem. 
    Would you be able to solve the problem using the dynamic programming approach?

    Input: coins - a list of integers, amount - an integer
    Output: the minimum number of coins required to make up the given amount
    """
    pass

def coin_change_dp(coins, amount):
    """In this function, we will find the minimum number of coins required to make up the given amount.
    
    Use the dynamic programming approach to solve the problem.
    See the difference in performance between the recursive and dynamic programming approach?
    
    Input: coins - a list of integers, amount - an integer
    Output: the minimum number of coins required to make up the given amount
    """
    pass

def test_max_element():
    print('Testing max_element function')
    assert max_element([0]) == 0
    assert max_element([1]) == 1
    assert max_element([1, 2, 3, 4, 5]) == 5
    assert max_element([1, 2, 3, 4, 5, 6]) == 6
    assert max_element([1, 2, 3, 4, 5, 6, 7]) == 7
    assert max_element([1, 2, 3, 4, 5, 6, 7, 8]) == 8
    assert max_element([1, 2, 3, 4, 5, 6, 7, 8, 9]) == 9
    assert max_element([1, 2, 3, 4, 5, 6, 7, 8, 9, 10]) == 10
    print('All simple test cases pass')

    import random
    test_case_a = [random.randint(0, 1000) for _ in range(1000)]
    assert(max_element(test_case_a) == max(test_case_a))

    print('All complex test cases pass')

def test_coin_change():

    print('Testing coin_change function')
    assert coin_change([1], 0) == 1
    assert coin_change([1], 1) == 1
    assert coin_change([1, 2], 5) == 3
    assert coin_change([1, 2, 5], 11) == 11
    assert coin_change([2], 3) == 0
    assert coin_change([1], 100) == 1
    assert coin_change([1, 2, 5], 100) == 541
    assert coin_change([1, 2, 5, 10, 20, 50, 100, 200], 200) == 73682
    print('All test cases pass')

def test_coin_change_dp():

    print('Testing coin_change_dp function')
    assert coin_change_dp([1], 0) == 1
    assert coin_change_dp([1], 1) == 1
    assert coin_change_dp([1, 2], 5) == 3
    assert coin_change_dp([1, 2, 5], 11) == 11
    assert coin_change_dp([2], 3) == 0
    assert coin_change_dp([1], 100) == 1
    assert coin_change_dp([1, 2, 5], 100) == 541
    assert coin_change_dp([1, 2, 5, 10, 20, 50, 100, 200], 200) == 73682
    print('All test cases pass')

if __name__ == '__main__':
    test_max_element()
    test_coin_change()
    test_coin_change_dp()
